<template>
    <f7-page 
        name="documentstatus" 
        @page:beforein="onPageBeforeIn"
        @page:beforeout="onPageBeforeOut">

        <!-- Top Navbar -->
		<f7-navbar :sliding="false">
            <f7-nav-left back-link></f7-nav-left>
            <f7-nav-title>{{ document != null ? document.title : 'Loading' }}</f7-nav-title>
		</f7-navbar>

        <f7-block strong inset v-if="document != null">
            <f7-row>
                <f7-col width="35">
                    <qrcode :value="document.tracking_number" :options="{ width: 100 }"></qrcode>
                </f7-col>
                <f7-col width="65">
                    <small>Tracking Number</small>
                    <h4 class="no-margin-top">{{ document.tracking_number }}</h4>
                    <small>Document Number</small>
                    <h4 class="no-margin-top">{{ document.document_number }}</h4>
                </f7-col>
            </f7-row>

            <f7-row>
                <f7-col>
                    <small>Title</small>
                    <h4 class="no-margin-top">{{ document.title }}</h4>
                </f7-col>
            </f7-row>
            <f7-row>
                <f7-col>
                    <small>Remarks</small>
                    <h4 class="no-margin-top">{{ document.remarks }}</h4>
                </f7-col>
            </f7-row>
            <f7-row>
                <f7-col>
                    <small>Author</small>
                    <h4 class="no-margin-top">{{ document.author.fullname }}, {{ document.author.organization.name }}</h4>
                </f7-col>
            </f7-row>
        </f7-block>        
        <f7-block strong inset v-if="user.organization.statuses.length > 0">
            <h4>Status</h4>
            <f7-list class="no-margin" no-hairlines inline-labels>
                <f7-list-item 
                    title="Select Status"                     
                    smart-select 
                    :smart-select-params="{
                        openIn: 'popup', 
                        closeOnSelect: true
                    }">
                    <select 
                        name="status"
                        :value="documentStatus.status"
                        @change="documentStatus.status = $event.target.value">
                        <option 
                            v-for="(status, idx) in user.organization.statuses"
                            :key="idx"
                            :value="status.id">{{ status.name.capitalize() }}{{ status.ispublic ? ' (Public)' : ' (Internal)' }}</option>
                    </select>
                </f7-list-item>
            </f7-list>
            <f7-list class="no-margin" no-hairlines>
                <f7-list-input
                    ref="note"
                    type="textarea"
                    label="Note"
                    placeholder="Write a note..."
                    resizable					
                    :value="documentStatus.note"
                    @input="documentStatus.note = $event.target.value">
                </f7-list-input>            
            </f7-list>
            <ul class="timeline">
                <li 
                    class="timeline-item"
                    v-for="(status, index) in document.statuses"
                    :key="index"
                    >
                    <div class="timeline-item-tail"></div>
                    <div class="timeline-item-node timeline-item-node-normal"></div>
                    <div class="timeline-item-wrapper">
                        <div class="timeline-timestamp">{{ dateFormat(status.created) }}</div>
                        <div class="timeline-item-content">
                            <h4 class="no-margin-bottom">{{ status.status.name }} <f7-icon v-if="status.notified" material="notifications_none"></f7-icon> </h4>
                            <small class="display-block">Updated By: {{ status.author.fullname }}</small>
                            <span class="display-block margin-small-top">{{ status.note }}</span>
                        </div>
                    </div>
                </li>
            </ul>
        </f7-block>
        <f7-block strong inset v-if="document != null && document.person_involves.length > 0">
            <h4>Person Involves</h4>
            <f7-list class="no-margin" no-hairlines inline-labels>
                <f7-list-item>
                    <span>Notify Person Involves?</span>
                    <f7-toggle 
                        :checked="documentStatus.notified" 
                        color="red"
                        @change="documentStatus.notified = $event.target.checked"></f7-toggle>
                </f7-list-item>
            </f7-list>
            <f7-list v-if="documentStatus.notified">
                <f7-list-item 
                    v-for="(person, index) in document.person_involves"
                    :key="index"
                    checkbox 
                    :title="person.fullname.capitalize() + ' ('+person.phone+')'" 
                    name="person_involves" 
                    :checked="documentStatus.persons.includes(person.phone)"
                    @change="handlePersonInvolveChange($event, person)">
                </f7-list-item>
            </f7-list>
        </f7-block>
        <f7-block>
            <f7-button @click="doSubmit" class="button-orange" fill large>Update Status</f7-button>
        </f7-block>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { parseError, dateFormat, convertAmpersand, bytesToSize } from '../js/utils';
export default {
    name: 'DocumentStatus',
    data(){
        return {
            documentStatus: {
                status: null,
                note: '',
                notified: false,
                persons: [],
            }
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('document', ['document'])
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;
    },
    methods: {
        dateFormat,
        convertAmpersand,
        bytesToSize,
        getDocument(){

            const self = this;
            const app = self.$f7;

            app.preloader.show('red');

            self.$store.dispatch('document/viewDocument', {
                id: self.$f7route.params.id
            }).then(()=>{
                app.preloader.hide();
            });
        },
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;
        },
        onPageBeforeOut(page){
            const self = this;
            const app = self.$f7;
        },
        handlePersonInvolveChange(e, person){
            const self = this;
            const app = self.$f7;

            if(e.target.checked == true){
                self.documentStatus.persons.push(person.phone);
            }else{
                const index = self.documentStatus.persons.indexOf(person.phone);
                self.documentStatus.persons.splice(index, 1);
            }
        },

        doSubmit(){
            const self = this;
            const app = self.$f7;

            if(self.documentStatus.status == null){
                app.dialog.alert('New status is required', 'Doctrin');
                return false;
            }else if(self.documentStatus.notified == true && self.documentStatus.persons.length == 0){
                app.dialog.alert('Select person involved to be notified', 'Doctrin');
                return false;
            }

            app.preloader.show('red');

            self.$store.dispatch('document/updateDocumentStatus', {
                id: self.$f7route.params.id,
                status: parseInt(self.documentStatus.status),
                note: self.documentStatus.note,
                notified: self.documentStatus.notified,
                persons: self.documentStatus.persons
            }).then(()=>{
                app.preloader.hide();
                if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'Doctrin');
					return false;
				}else{
					self.$f7router.navigate('/', {
                        ignoreCache: true
                    })
				}
            });
        }
    },

}
</script>